﻿using System;

namespace analýza
{
    //using T = System.String;


    class Prvek<T>
    {
        private T data;
        private Prvek<T> další;
        public Prvek(T _data) { NastavData(_data); další = null; }
        public T VraťData() { return data; }
        public void NastavData(T _data) { data = _data; }
        public Prvek<T> VraťDalší() { return další; }
        public void NastavDalší(Prvek<T> p) { další = p; }
    }

    class Seznam<T> where T: IComparable
    {
        private Prvek<T> hlava;             // Odkaz na první prvek seznamu
        public Seznam() { hlava = null; }

        public void VložNaKonec(T co)       // Zařaď nový prvek na konec seznamu
        {
            if (Prázdný())              // Je-li seznam prázdný
            {
                hlava = new Prvek<T>(co);
            }
            else                            // Není-li prázdný
            {
                Prvek<T> pom1 = hlava, pom2 = null;
                while (pom1 != null)        // Najdi konec seznamu
                {
                    pom2 = pom1;            // q bude obsahovat odkaz na poslední prvek
                    pom1 = pom1.VraťDalší();
                }
                pom2.NastavDalší(new Prvek<T>(co));// Připoj nový prvek
            }
        }

        public void VložNaPočátek(T co)     // zařaď nový prvek na počátek seznamu
        {
            Prvek<T> p = hlava;             // Ulož si odkaz na první prvek
            hlava = new Prvek<T>(co);       // Vlož nový
            hlava.NastavDalší(p);           // a připoj zbytek
        }

        public void Vypiš()                 // Vypiš seznam
        {
            Prvek<T> p = hlava;
            while (p != null)
            {
                System.Console.Write(p.VraťData() + " ");
                p = p.VraťDalší();
            }
        }

        public bool Prázdný() => hlava == null;

        public bool Obsahuje(T co)         // Zjisti, zda je hodnota co v seznamu
        {                                   // Pokud ano, vrať odkaz na prvek
            Prvek<T> p = hlava;
            while (p != null && !p.VraťData().Equals(co))
            {
                p = p.VraťDalší();
            }
            return p != null;
        }

        // Implementace algoritmu třídění výběrem (selection sort)
        public void Seřaď()                 // Seřaď prvky seznamu podle velikosti
        {                                   // od nejmenšího (tedy podle abecedy)
            if (Prázdný()) { return; }      // Je-li seznam prázdný, není co třídit
            Prvek<T> p = hlava, q = null, r = null;
            while (p.VraťDalší() != null)   // p: Odkaz na první prvek úseku
            {                               // q: prochází úsek
                q = p.VraťDalší();          // r: pamatuje se dosud nalezený nejmenší
                r = p;
                while (q != null)       // Projdi prvky úseku
                {
                    if (q.VraťData().CompareTo(r.VraťData()) <= 0)
                    {
                        r = q;          // Pokud najdeš menší prvek, zapamatuj si ho
                    }

                    q = q.VraťDalší();
                }
                T pom = r.VraťData();   // Prohoď nejmenší s prvním
                r.NastavData(p.VraťData());
                p.NastavData(pom);      // Nejmenší prvek úseku je nyní na svém místě,
                p = p.VraťDalší();      // vezmi úsek začínající o jeden prvek dál
            }  
        }

        // Odstraní všechny prvky ze seznamu
        public void Vyprázdni() => hlava = null; // Vše obstará garbage collector...
    }
}
