// Soubor Kalend.cs
// Program pete datum jako ti cel sla a vypote, kolik dn
// od potku roku ubhlo.
//
// Pouv Vstup.DLL, take nutno pekldat pkazem
// csc /r: Vstup.DLL kalend.cs

using System;
using Knihovna;

namespace Kalend
{
    class Kalend
    {
        readonly int[] msce = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
        int[] dny = new int[12];
        public Kalend()
        {   // Konstruktor ulo do pole dny poty dn, kter obhly do zatku odpovdajcto msce
            int i = 1;
            while (i < dny.Length)
            {
                dny[i] = dny[i - 1] + msce[i - 1];
                ++i;
            }
        }

        public bool JePestupn(int rok)  // Je dan rok pestupn?
        {
            return ((rok % 4 == 0) && (rok % 100 != 0)) || (rok % 400 == 0);
        }

        public int sloDne(int den, int msc, int rok)    // Zjist slo dne
        {
            int vsledek = dny[msc - 1] + den;
            if (JePestupn(rok) && msc > 2) ++vsledek;
            return vsledek;
        }
    }

    public class Program
    {
        public static void Main()
        {
            int den, msc, rok;
            Console.Write("Zadej den, msc a rok: ");
            den = Vstup.tiInt();
            msc = Vstup.tiInt();
            rok = Vstup.tiInt();
            Kalend k = new Kalend();
            Console.WriteLine("{0}. {1}. je {2}. den od potku roku {3}", 
                              den, msc, k.sloDne(den, msc, rok), rok);
        }
    }
}