// Soubor delegt.cs
// ukazuje pouit delegt
//
// TdaFiltr je tda, kter obsahuje metodu HkyArky,
// kter vrac true, dostane-li jako parametr esk nebo slovensk znak s diakritickm znamnkem, jinak vrac false.
//
// Ve 2. dku deklarujeme delegt, kter me odkazovat ne metodu typu bool s jednm parametrem typu char.
//
// Ve td Program deklarujeme metodu Pefiltruj(), kter m jako druh parametr delegt "schvaluji" naeho typu. 
// Tato metoda dostane jako parametr znakov etzec a vrt etzec, kter obsahuje jen znaky 
// vyhovujc filtru zadanmu delegtem.
//
// V metod Main() nejprve vytvome instanci tdy TdaFiltr, pak vytvome delegt odkazujc na 
// metodu HkyArky a ten pedme metod Pefiltruj(), kter vrt pefiltrovan etzec.

namespace delegace
{
    using System;
    public delegate bool Filtr(char znak);

    public class TdaFiltr
    {
        private string ZNAKY_S_DIAKRITIKOU = "؊ݎž";
        public bool HkyArky(char znak)
        {
            return (ZNAKY_S_DIAKRITIKOU.IndexOf(znak) != -1);
        }
        // A dal metody...
    }

    public class Program
    {
        public static string Pefiltruj(string text, Filtr schvaluji)
        {
            System.Text.StringBuilder vsledek = new System.Text.StringBuilder("");
            int i = 0;
            while (i < text.Length)
            {
                if (schvaluji(text[i])) vsledek.Append(text[i]);
                i++;
            }
            return vsledek.ToString();
        }
        public static void Main()
        {
            Console.WriteLine("Napi njak text: ");
            string s = Console.ReadLine();
            TdaFiltr filtry = new TdaFiltr();
            // new Filtr(filtry.HkyArky);
            System.Console.WriteLine(Pefiltruj(s, filtry.HkyArky));
        }
    }
}