// Soubor Konvert.cs
// tda pro pevod mezi selnmi soustavami 
//
// Peklad:
// csc /r:Vstup.dll fakt1.cs
// V adresi mus bt soubor vstup.dll
//

using System;
using System.Text;
using Knihovna;

namespace konverze
{
    public class Konvertor
    {
        private const string SLICE = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        private int zklad;
        public Konvertor(int _zklad)
        {
            if (_zklad < 2) throw new Exception("Zklad men ne 2");
            if (_zklad > 36) throw new Exception("Zklad vt ne 36");
            zklad = _zklad;
        }
        public string Konvertuj(int n)
        {
            if (n == 0)
            {
                return "0";
            }
            StringBuilder slo = new StringBuilder("");
            bool zporn = n < 0;
            if (zporn)
            {
                n = Math.Abs(n);
            }
            while (n != 0)
            {
                slo.Append(SLICE[n % zklad]);
                n /= zklad;
            }
            if (zporn)
            {
                slo.Append("-");
            }
            int i = 0, j = slo.Length - 1;
            while (i < j)
            {
                char pom = slo[i];
                slo[i++] = slo[j];
                slo[j--] = pom;
            }
            return slo.ToString();
            //char[] znaky = slo.ToString().ToCharArray();
            //Array.Reverse(znaky);
            //return new string(znaky);
        }
    }

    class Test
    {
        static void Main()
        {
            Console.Write("Zadej zklad clov soustavy (2 - 36): ");
            int zklad = Vstup.tiInt();
            Konvertor konvertor = new Konvertor(zklad);
            Console.Write("Zadej slo, kter do n chce pevst: ");
            int co = Vstup.tiInt();
            Console.WriteLine(konvertor.Konvertuj(co));
            //Console.Read();
        }
    }
}