using System;
using System.Collections.Generic;
using System.Linq;

public class Program
{
    public static void Main()
    {
        var hodnoty = new List<object>();
        for (int ctr = 0; ctr <= 7; ctr++)
        {
            if (ctr == 2)
                hodnoty.Add(Kostka.Vrh2());
            else if (ctr == 4)
                hodnoty.Add(Kostka.Vynech());
            else
                hodnoty.Add(Kostka.Vrh());
        }

        Console.WriteLine("Souet {0} kostky je {1}", hodnoty.Count, Kostka.Souet(hodnoty));
    }
}

public static class Kostka
{
    // Genertor pseudonhodnch sel pro simulaci vrh kostkou
    static Random genertor = new Random();

    // Jeden vrh kostku
    public static int Vrh()
    {
        return genertor.Next(1, 7);
    }

    // Vrh dvma kostkami
    public static List<object> Vrh2()
    {
        var vrhy = new List<object>();
        vrhy.Add(Vrh());
        vrhy.Add(Vrh());
        return vrhy;
    }

    // Vpoet soutu vsledk vrh
    public static int Souet(IEnumerable<object> hodnoty)
    {
        var souet = 0;
        foreach (var poloka in hodnoty)
        {
            switch (poloka)
            {
                // Samotn nula
                case 0:
                    break;
                // Jedin hodnota
                case int hodnota:
                    souet += hodnota;
                    break;
                // Neprzdn kolekce
                case IEnumerable<object> podseznam when podseznam.Any():
                    souet += Souet(podseznam);
                    break;
                // Przdn kolekce
                case IEnumerable<object> podseznam:
                    break;
                //  Odkaz null
                case null:
                    break;
                // Ani slo, ani kolekce
                default:
                    throw new InvalidOperationException("Poloka neznmho typu");
            }
        }
        return souet;
    }

    public static object Vynech()
    {
        if (genertor.Next(0, 2) == 0)
            return null;
        else
            return new List<object>();
    }
}