using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;

#nullable enable
namespace opertorswitch
{
    public class Bod
    {
        public int X { get; }
        public int Y { get; }

        public Bod(int x, int y) => (X, Y) = (x, y);

        public void Deconstruct(out int x, out int y) =>
            (x, y) = (X, Y);
    }

    public enum Kvadrant
    {
        Neznm,
        Potek,
        Prvn,
        Druh,
        Tet,
        tvrt,
        Hranice
    }

    class Program
    {
        public static Kvadrant UriKvadrant(Bod point) => point switch
        {
            (0, 0) => Kvadrant.Potek,
            var (x, y) when x > 0 && y > 0 => Kvadrant.Prvn,
            var (x, y) when x < 0 && y > 0 => Kvadrant.Druh,
            var (x, y) when x < 0 && y < 0 => Kvadrant.Tet,
            var (x, y) when x > 0 && y < 0 => Kvadrant.tvrt,
            var (_, _) => Kvadrant.Hranice,
            _ => Kvadrant.Neznm
        };
        static int F(int n)
        {
            return (1+n) switch
            {
                0 => 2 + n,
                3 => 3,
                _ => 9,
            };
        }

        public static string KmenPaprNky(string prvn, string druh)
    => (prvn, druh) switch
    {
        ("kmen", "papr") => "Papr zabal kmen. Druh vyhrv.",
        ("kmen", "nky") => "Kmen otup nky. Prvn vyhrv.",
        ("papr", "kmen") => "Papr zabal kmen. Prvn vyhrv.",
        ("papr", "nky") => "Nky pestihnou papr. Druh vyhrv.",
        ("nky", "kmen") => "Kmen otup nky. Druh vyhrv.",
        ("nky", "papr") => "Nky pestihnou papr. Prvn vyhrv.",
        (_, _) => "Nerozhodn."
    };

        static void Main(string[] args)
        {
            Console.WriteLine(F(-1));
            Console.WriteLine(KmenPaprNky("papr", "kmen"));
            Console.WriteLine(UriKvadrant(new Bod(-1, 3)));
        }
    }
}
