using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace novswitch
{
    class NovSwitch
    {
        static void Main(string[] args)
        {
            int[] hodnoty = { 2, 4, 6, 8, 10 };
            InfoOKolekci(hodnoty);

            var jmna = new List<string>();
            jmna.AddRange(new string[] { "Adam", "Eva", "Karel", "Mirka" });
            InfoOKolekci(jmna);

            List<int> sla = null;
            InfoOKolekci(sla);

            sla = new List<int>(hodnoty);
            InfoOKolekci(sla);

            InfoOKolekci(new Queue(hodnoty));
            InfoOKolekci(1);
        }

        private static void InfoOKolekci(object kolekce)
        {
            switch (kolekce)
            {
                case Array pole when pole.Length > 0:
                    Console.WriteLine("Pole o {0} prvcch.", pole.Length);
                    break;
                case Array pole when pole.Length == 0:
                    Console.WriteLine("Przdn pole.", pole.Length);
                    break;
                case IEnumerable<int> kolekceCelchsel:
                    Console.WriteLine("Prmr: {0}", kolekceCelchsel.Average(s => s));
                    break;
                case IList seznam when seznam.Count > 0:
                    Console.WriteLine("Seznam o {0} polokch", seznam.Count);
                    break;
                case IEnumerable obecnKolekce:
                    string vsledek = "";
                    foreach (var poloka in obecnKolekce)
                    {
                        vsledek += (poloka + " ");
                    }

                    Console.WriteLine("V kolekci je " + vsledek);
                    break;
                case null:
                    Console.WriteLine("Kde nic nen, ani smrt nebere");
                    break;
                default:
                    Console.WriteLine("Instance typu " + kolekce.GetType().Name);                  
                    break;
            }
        }
    }
}