using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace konverze
{
    public class Konvertor
    {
        private const string SLICE = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        private int zklad;
        public Konvertor(int _zklad)
        {
            if (_zklad < 2) throw new Exception("Zklad men ne 2");
            if (_zklad > 36) throw new Exception("Zklad vt ne 36");
            zklad = _zklad;
        }
        public string Konvertuj(int n)
        {
            if (n == 0)
            {
                return "0";
            }
            StringBuilder slo = new StringBuilder("");
            bool zporn = n < 0;
            if (zporn)
            {
                n = Math.Abs(n);
            }
            while (n != 0)
            {
                slo.Append(SLICE[n % zklad]);
                n /= zklad;
            }
            if (zporn)
            {
                slo.Append("-");
            }
            char[] znaky = slo.ToString().ToCharArray();
            Array.Reverse(znaky);
            return new string(znaky);
        }
    }
    class Program
    {
        private static string textNpovdy = 
@"Pevod zadanho sla do soustavy s danm zkladem. 
Pouit:

pevod cel_slo zklad_soustavy

Zklad clov soustavy mus leet v rozmez 2 .. 35
vetn obou krajnch hodnot.";
        private static void Npovda()
        {
            Console.WriteLine(textNpovdy);
            Environment.Exit(1);
        }
        private static (int slo, int zklad) ZpracujParametry(string[] parametry)
        {
            if (parametry.Length != 2) Npovda();
            bool povedloSeslo = int.TryParse(parametry[0], out int slo);
            bool povedlSeZklad = int.TryParse(parametry[1], out int zklad);
            if (!(povedloSeslo && povedlSeZklad && (zklad >= 2) && (zklad <= 36)))
            {
                Npovda();
            }
            return (slo, zklad);
        }
        static void Main(string[] zadn)
        {
            var data = ZpracujParametry(zadn);
            Console.WriteLine( 
                new Konvertor(data.zklad).Konvertuj(data.slo));
        }
    }
}
