// Soubor udlost.CS
// Ukazuje deklaraci tdy pro penos informac 
// o udlosti, delegtu pro udlost
// deklaraci udlosti ve td, handleru v jin td,
// zaregistrovn udlosti a vyvoln udlosti

using System;
namespace udlost
{

    // Tda pro penos informac o udlosti
    public class TlatkoEventArgs : EventArgs
    {
        public TlatkoEventArgs(string kdo) { Kdo = kdo; }
        public string Kdo { get; private set; }
    }

    // Delegt pro udlost
    public delegate void UdlostTlatka(object zdroj, TlatkoEventArgs e);

    // Tlatko:  tda, kter me vyvolat udlost
    public class Tlatko
    {
        private string nzev;
        public Tlatko(string jmno) { nzev = jmno; }
        public event UdlostTlatka Stisknut;         // deklarace udlosti
        public void Stiskni()                           // Stisknut vyvol udlost
        {
            if (Stisknut != null) Stisknut(this, new TlatkoEventArgs(nzev));
        }

    }

    public class Program
    {
        // Obsluha udlosti
        static void StiskTlatka(object zdroj, TlatkoEventArgs e)
        {
            Console.WriteLine("Nkdo stiskl tlatko " + e.Kdo + ".");
        }
        public static void Main()
        {
            Tlatko T1 = new Tlatko("Ano"), T2 = new Tlatko("Ne");
            T1.Stisknut += StiskTlatka; // Registrace zjemce o udlost
            T1.Stisknut += (zdroj, e) => Console.WriteLine("A zase.");
            T2.Stiskni(); // To me vyvolat udlost
            T1.Stiskni();
        }
    }
}