using System;
using System.Linq;

namespace NDamKonzolově
{
    class Program
    {
        private static int CelkovýPočetŘešení(Řešitel řešitel)
        {
            return řešitel.Řešení.Count();
        }

        private static void VypišPole(int[] pole)
        {
            Console.Write("(");
            for(int i = 0; i < pole.Length; i++) 
            {
                Console.Write((i == 0 ? "" : ", ") + pole[i]);
            }
            Console.WriteLine(")");
        }

        private static void VypišVšechnaŘešení(Řešitel řešitel)
        {
            foreach(var řešení in řešitel.Řešení)
            {
                VypišPole(řešení);
            }
        }

        private static void VypišVšechnaŘešeníZačínajícíŘádkou(int početDam, int řádka)
        {
            var dotaz = from řešení in new Řešitel(početDam).Řešení
                        where řešení[0] == řádka
                        select řešení;
            foreach (var pole in dotaz)
            {
                VypišPole(pole);
            }
        }

        static void Main(string[] args)
        {
            // Chybné znovupoužití řešitele
            //var řešitel1 = new Řešitel(4);
            //Console.WriteLine(CelkovýPočetŘešení(řešitel1));
            //VypišVšechnaŘešení(řešitel1);

            Console.WriteLine(CelkovýPočetŘešení(new Řešitel(8)));
            VypišVšechnaŘešení(new Řešitel(4));
            VypišVšechnaŘešeníZačínajícíŘádkou(početDam: 5, řádka: 1);
        }
    }
}
