using System;
using System.Collections.Generic;
using System.Linq;

namespace kontakty
{
    public enum TypKontaktu { Soukrom, Pracovn };
    class Kontakt
    {
        public string Jmno { get; set; }
        public string Pjmen { get; set; }
        public string Telefon { set; get; }
        public TypKontaktu Typ { set; get; }
        public int RokSeznmen { get; set; }
        public Kontakt(string jmno, string pjmen, string telefon, TypKontaktu typ, int rok) => (Jmno, Pjmen, Telefon, Typ, RokSeznmen) = (jmno, pjmen, telefon, typ, rok);
        public override string ToString()
        {
            return $"{Pjmen}, {Jmno} ({Typ}: {Telefon}, od r. {RokSeznmen})";
        }
    }

    

    class Program
    {
        private static List<Kontakt> kontakty = new List<Kontakt>();
        private static void Pprava()
        {
            kontakty.Add(new Kontakt("Josef", "Novk", "523856581", TypKontaktu.Pracovn, 2015));
            kontakty.Add(new Kontakt("Jan", "Vopika", "123456789", TypKontaktu.Pracovn, 1999));
            kontakty.Add(new Kontakt("Jan", "Novk", "852741963", TypKontaktu.Soukrom, 2018));
            kontakty.Add(new Kontakt("Iva", "Klapalov", "121454585", TypKontaktu.Soukrom, 2019));
            kontakty.Add(new Kontakt("Vclav", "Maek", "321654987", TypKontaktu.Pracovn, 2020));
            kontakty.Add(new Kontakt("Karel", "Mrek", "987654123", TypKontaktu.Soukrom, 2015));
            kontakty.Add(new Kontakt("Hana", "Mazan", "326598741", TypKontaktu.Pracovn, 2017));
            kontakty.Add(new Kontakt("Josef", "Novk", "313265649", TypKontaktu.Pracovn, 2014));

        }

        static void Main(string[] args)
        {
            Pprava();
            int[] pole = { 9, 7, 99, 5, 4, -4, 8, 4 };
            double prmr = pole.Average();
            Console.WriteLine($"Prmr hodnot z pole je {prmr}");
            int prvn = kontakty.Min(kon => kon.RokSeznmen);
            Kontakt nejstar = (from kontakt in kontakty where kontakt.RokSeznmen == prvn select kontakt).First();
            Console.WriteLine(nejstar);
            int prvnNovk = (from kontakt in kontakty
                              where kontakt.Pjmen == "Novk"
                              select kontakt.RokSeznmen).DefaultIfEmpty(0).Min();
            Console.WriteLine($"Prvn Novk: {prvnNovk}");
        }
        

    }
}
