using System;
using System.Linq;
using System.Collections.Generic;

namespace pokusySLinq
{
    class Program
    {
        private static readonly Dictionary<int, string> seznamAutor = new Dictionary<int, string>();
        private static readonly Dictionary<int, string> seznamKnih = new Dictionary<int, string>();
        private static readonly List<(int sloAutora, int sloKnihy)> autorstv= new List<(int, int)>();

        private static void Pprava()
        {
            seznamAutor[1] = "Karel apek";  // Pidv nov hodnoty do slovnku
            seznamAutor[2] = "Brian Greene";
            seznamAutor[3] = "Miroslav Holub";
            seznamAutor[4] = "Ota Janeek";

            seznamKnih[1] = "Povdky z jedn kapsy";
            seznamKnih[2] = "Struktura vesmru";
            seznamKnih[3] = "Sagitln ez";
            seznamKnih[4] = "Povdky z druh kapsy";

            autorstv.Add((1, 1));
            autorstv.Add((2, 2));
            autorstv.Add((3, 3));
            autorstv.Add((4, 3));
            autorstv.Add((1, 4));
        }
        private static void Vpis<T>(IEnumerable<T> data)
        {
            foreach(var daj in data)
            {
                Console.WriteLine(daj);
            }
            Console.WriteLine("---");
        }
        static void Main(string[] args)
        {
            Pprava();
            var dotaz = from autor in seznamAutor
                        join propojen in autorstv on autor.Key equals propojen.sloAutora
                        join kniha in seznamKnih on propojen.sloKnihy equals kniha.Key
                        select autor.Value + ": " + kniha.Value;
            Vpis(dotaz);


            var dotaz1 = from autor in seznamAutor
                         from propojen in autorstv
                         from kniha in seznamKnih
                         where (kniha.Key == propojen.sloKnihy) && (propojen.sloAutora == autor.Key)
                         select autor.Value + ": " + kniha.Value;
            Vpis(dotaz1);
        }
    }
}
