using System;
using System.Collections.Generic;
using System.Linq;

namespace kontakty
{
    public enum TypKontaktu { Soukrom, Pracovn };
    class Kontakt
    {
        public string Jmno { get; set; }
        public string Pjmen { get; set; }
        public string Telefon { set; get; }
        public TypKontaktu Typ { set; get; }
        public Kontakt(string jmno, string pjmen, string telefon, TypKontaktu typ) => (Jmno, Pjmen, Telefon, Typ) = (jmno, pjmen, telefon, typ);
        public override string ToString()
        {
            return $"{{{Jmno} {Pjmen} ({Typ}: {Telefon})}}";
        }
    }


    class Program
    {
        private static List<Kontakt> kontakty = new List<Kontakt>();
        private static void Pprava()
        {
            kontakty.Add(new Kontakt("Jan", "Vopika", "123456789", TypKontaktu.Pracovn));
            kontakty.Add(new Kontakt("Iva", "Klapalov", "121454585", TypKontaktu.Soukrom));
            kontakty.Add(new Kontakt("Vclav", "Maek", "321654987", TypKontaktu.Pracovn));
            kontakty.Add(new Kontakt("Karel", "Mrek", "987654123", TypKontaktu.Soukrom));
            kontakty.Add(new Kontakt("Hana", "Mazan", "326598741", TypKontaktu.Pracovn));
        }

        private static void Vpis<T>(IEnumerable<T> data)
        {
            foreach(var daj in data)
            {
                Console.WriteLine(daj);
            }
            Console.WriteLine("---");
        }
        static void Main(string[] args)
        {
            Pprava();

            var dotaz = from kontakt in kontakty
                            orderby kontakt.Pjmen
                            select kontakt.Pjmen + ": " + kontakt.Telefon;
            Vpis(dotaz);
            IEnumerable<string> dotaz2 = 
                kontakty.OrderBy(kontakt => kontakt.Pjmen).Select(kontakt => kontakt.Pjmen + ": " + kontakt.Telefon);
            Vpis(dotaz2);
            IEnumerable<string> dotaz3 =
                Enumerable.Select<Kontakt, string>
                (
                    Enumerable.OrderBy<Kontakt, string>(kontakty, kontakt => kontakt.Pjmen),
                    kontakt => kontakt.Pjmen + ": " + kontakt.Telefon
                );
            Vpis(dotaz3);
        }
    }
}
