using System;
using System.Collections.Generic;
using System.Linq;

namespace kontakty
{
    public enum TypKontaktu { Soukrom, Pracovn };
    class Kontakt
    {
        public string Jmno { get; set; }
        public string Pjmen { get; set; }
        public string Telefon { set; get; }
        public TypKontaktu Typ { set; get; }
        public Kontakt(string jmno, string pjmen, string telefon, TypKontaktu typ) => (Jmno, Pjmen, Telefon, Typ) = (jmno, pjmen, telefon, typ);
        public override string ToString()
        {
            return $"{{{Jmno} {Pjmen} ({Typ}: {Telefon})}}";
        }
    }


    class Program
    {
        private static List<Kontakt> kontakty = new List<Kontakt>();
        private static void Pprava()
        {
            kontakty.Add(new Kontakt("Jan", "Vopika", "123456789", TypKontaktu.Pracovn));
            kontakty.Add(new Kontakt("Iva", "Klapalov", "121454585", TypKontaktu.Soukrom));
            kontakty.Add(new Kontakt("Vclav", "Maek", "321654987", TypKontaktu.Pracovn));
            kontakty.Add(new Kontakt("Karel", "Mrek", "987654123", TypKontaktu.Soukrom));
            kontakty.Add(new Kontakt("Hana", "Mazan", "326598741", TypKontaktu.Pracovn));
        }

        private static void Vpis<T>(IEnumerable<T> data)
        {
            foreach(var daj in data)
            {
                Console.WriteLine(daj);
            }
            Console.WriteLine("---");
        }
        static void Main(string[] args)
        {
            Pprava();

            var dotaz = from kontakt in kontakty
                        orderby kontakt.Pjmen
                        group kontakt by kontakt.Typ;
            foreach (var skupina in dotaz)
            {
                Console.WriteLine("--" + skupina.Key + "--");
                foreach (Kontakt kontakt in skupina)
                {
                    Console.WriteLine(kontakt.Pjmen + ": " + kontakt.Telefon);
                }
            }
            Console.WriteLine("===========");

            var dotaz2 = from kontakt in kontakty
                            orderby kontakt.Pjmen
                            group kontakt.Pjmen + ": " + kontakt.Telefon by kontakt.Typ;
            foreach (var skupina in dotaz2)
            {
                Console.WriteLine("--" + skupina.Key + "--");
                //foreach (var dataKontaktu in skupina)
                //{
                //    Console.WriteLine(dataKontaktu);
                //}
                Vpis(skupina);
            }

            Console.WriteLine("===========");

            var dotaz3 = kontakty.OrderBy(kontakt => kontakt.Pjmen).
                GroupBy(kontakt => kontakt.Typ, kontakt => kontakt.Pjmen + " :" + kontakt.Telefon);
            foreach (var skupina in dotaz2)
            {
                Console.WriteLine("--" + skupina.Key + "--");
                Vpis(skupina);
            }
        }

    }
}
