using System;
using System.IO;

namespace Binrn
{
    class Program
    {
        private static readonly string jmno = "data.dta";
        public static void ZapiBinrn(string jmno)
        {
            using (BinaryWriter zapisova = new BinaryWriter(new FileStream(jmno, FileMode.Create, FileAccess.Write)))
            {
                zapisova.Write(0x12345678);
                for (int i = 0; i < 10; i++)
                {
                    zapisova.Write(i);
                }
            }
        }

        public static void ZapiBinrnBezUsing(string jmno)
        {
            FileStream podklad = null;
            BinaryWriter zapisova = null;
            try
            {
                podklad = new FileStream(jmno, FileMode.Create, FileAccess.Write);
                zapisova = new BinaryWriter(podklad);
                for (int i = 0; i < 10; i++)
                {
                    zapisova.Write(i);
                }
            }
            finally
            {
                if (zapisova != null) zapisova.Close();
            }
        }

        public static void PipiNaKonecBinrn(string jmno)
        {
            using (BinaryWriter zapisova = new BinaryWriter(new FileStream(jmno, FileMode.Append, FileAccess.Write)))
            {
                for (int i = 10; i < 20; i++)
                {
                    zapisova.Write(i);
                }
            }
        }

        public static void PetiBinrn (string jmno)
        {
            using (BinaryReader teka = new BinaryReader(new FileStream(jmno, FileMode.Open, FileAccess.Read)))
            {
                while (teka.BaseStream.Position < teka.BaseStream.Length)
                {
                    int i = teka.ReadInt32();
                    System.Console.WriteLine(i);
                }
            }
        }

        public static void Aktualizuj(string jmno)
        {
            using (FileStream podklad = new FileStream(jmno, FileMode.Open, FileAccess.ReadWrite))
            using (BinaryWriter zapisova = new BinaryWriter(podklad))
            using (BinaryReader teka = new BinaryReader(podklad))
            {
                while (podklad.Position < podklad.Length)
                {
                    int pozice = (int)podklad.Position;
                    int i = teka.ReadInt32();
                    if (i % 2 == 0)
                    {
                        i /= 2;
                        zapisova.Seek(pozice, SeekOrigin.Begin);
                        zapisova.Write(i);
                    }
                }
            }
        }

        static void Main(string[] parametry)
        {
            //ZapiBinrn(jmno);
            //PipiNaKonecBinrn(jmno);
            Aktualizuj(jmno);
            PetiBinrn(jmno);
        }
    }
}
