using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace neserializovateln
{
    public class NeserializovatelnHodnota
    {
        public int Hodnota { get; set; }
        public NeserializovatelnHodnota(int hodnota)
        {
            Hodnota = hodnota;
        }
        public override string ToString() => "" + Hodnota;
    }

    [Serializable]
    public class Nstroj: ISerializable
    {
        private NeserializovatelnHodnota hodnota;
        private int dalHodnota;
        public Nstroj(NeserializovatelnHodnota nsh, int dal) => (hodnota, dalHodnota) = (nsh, dal);
        public void Vpis()
        {
            Console.WriteLine(hodnota + ", " + dalHodnota);
        }
        public void GetObjectData(SerializationInfo info, StreamingContext kontext)
        {
            info.AddValue("neserializovateln", hodnota.Hodnota);
            info.AddValue("dal", dalHodnota);
        }

        protected Nstroj(SerializationInfo info, StreamingContext kontext)
        {
            hodnota = new NeserializovatelnHodnota(info.GetInt32("neserializovateln"));
            dalHodnota = info.GetInt32("dal");
        }
        public override bool Equals(object obj)
        {
            if(obj is Nstroj nstroj)
            {
                return (nstroj.hodnota.Hodnota == this.hodnota.Hodnota) && (nstroj.dalHodnota == dalHodnota);
            }
            else
            {
                return false;
            }
        }
    }


    
    class Program
    {
        static string jmno = "data.bin";
        static void Main(string[] args)
        {
            Nstroj nstroj = new Nstroj(new NeserializovatelnHodnota(42), 24);
            nstroj.Vpis();

            using (FileStream proud = new FileStream(jmno, FileMode.Create, FileAccess.Write))
            {
                BinaryFormatter serializtor = new BinaryFormatter();
                serializtor.Serialize(proud, nstroj);
            }

            Nstroj novNstroj;
            using (FileStream proud = new FileStream(jmno, FileMode.Open, FileAccess.Read))
            {
                BinaryFormatter serializtor = new BinaryFormatter();
                novNstroj = serializtor.Deserialize(proud) as Nstroj;
            }
            if(novNstroj.Equals(nstroj))
            {
                Console.WriteLine("ano");
            }

        }
    }
}
