using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

namespace pamov
{
public class BajtovKonvertor
{
    public static byte[] PevodNaBajty(long co)
    {
        using (BinaryWriter proud = new BinaryWriter(new MemoryStream(8)))
        {
            proud.Write(co);
            return ((MemoryStream)proud.BaseStream).GetBuffer();
        }
    }
    public static long PevodZBajt(byte[] co)
    {
        using (BinaryReader proud = new BinaryReader(new MemoryStream(co)))
        {
            return proud.ReadInt64();
        }
    }
}
    class Program
    {
        public static string PipojKetzci(string etzec, params object[] co)
        {
            using (var zapisova = new StringWriter(new StringBuilder(etzec)))
            {
                for (int i = 0; i < co.Length; i++)
                {
                    zapisova.Write((i == 0 ? "" : ", ") + co[i]);
                }
                return zapisova.GetStringBuilder().ToString();
            }
        }

        static void Main(string[] parametry)
        {
            var vsledek = PipojKetzci("Jsou to sla: ", 2, 88, 8);
            Console.WriteLine(vsledek);
            long numero = 0x123456789abcdef1;
            var bajty = BajtovKonvertor.PevodNaBajty(numero);
            foreach(var bajt in bajty)
            {
                Console.Write($"{bajt:X2} ");
            }
            long zptky = BajtovKonvertor.PevodZBajt(bajty);
            Console.WriteLine($"\n{zptky:X}\n");

        }
    }
}
