using System;
using System.IO;

namespace soubory
{
    class Program
    {
        public static void VpisAdrese(DirectoryInfo adres)
        {
            System.Console.WriteLine("Vpis adrese " + adres.FullName);
            DirectoryInfo[] podadrese = adres.GetDirectories();
            FileInfo[] soubory = adres.GetFiles();
            if (soubory.Length > 0)
            {
                System.Console.WriteLine("Soubory: ");
                foreach (var soubor in soubory)
                {
                    Console.WriteLine($"\t{soubor.Name}\t({soubor.Length} B)");
                }
            }
            if (podadrese.Length > 0)
            {
                System.Console.WriteLine("Podadrese:");
                foreach (var podadres in podadrese)
                {
                    System.Console.WriteLine($"\t{podadres.Name}");
                }
            }
        }
        static void Main(string[] parametry)
        {
            if (parametry.Length > 1)
            {
                System.Console.WriteLine("Pouit: adres [cesta]\n");
                return;
            }
            string cesta = parametry.Length == 1 ? parametry[0] : ".";
            //cesta = @"d:\!Psan\Cis pro zatenky\";
            DirectoryInfo adres = new DirectoryInfo(cesta);
            if (adres.Exists)
            {
                VpisAdrese(adres); 
            }
            else
            {
                System.Console.WriteLine("Adres " + cesta + " neexistuje.");
            }
        }
    }
}
