﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProblémNDam
{
    public partial class Okno : Form
    {
        private int kolik = 0;
        private Řešitel řešitel = null;
        bool nalezeno = false;
        int[] řešení;
        public Okno()
        {
            InitializeComponent();
        }

        private void PřipravŘešitele()
        {
            kolik = (int)číselníkPočetDam.Value;
            řešitel = new Řešitel(kolik);
        }

        private void MenuNová_Click(object sender, EventArgs e)
        {
            PřipravŘešitele();
            NastavTitulek(kolik, řešitel.PočetNalezenýchŘešení);
            menuDalší.Enabled = true;
            tlačítkoDalší.Enabled = true;
            nalezeno = false;
            panel.Invalidate();
        }

        private void NastavTitulek(int kolik, int početŘešení)
        {
            Text = $"Problém {kolik} dam, nalezeno {početŘešení} řešení";
        }

        private static void Neimplementováno()
        {
            MessageBox.Show("Tato možnost zatím není implementována.", "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void MenuDalší_Click(object sender, EventArgs e)
        {
            nalezeno = řešitel.NajdiDalšíŘešení(out řešení);
            if(!nalezeno)
            {
                MessageBox.Show("Další řešení neexistují.", "To je vše", MessageBoxButtons.OK, MessageBoxIcon.Information);
                menuDalší.Enabled = false;
                tlačítkoDalší.Enabled = false;
            }
            panel.Invalidate();
            NastavTitulek(kolik, řešitel.PočetNalezenýchŘešení);
        }

        private void MenuKonec_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void MenuOProgramu_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Úloha N dam\n© Piškvorky software, s.b.r. 2020", "O programu");
        }

        private void Okno_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (MessageBox.Show("Opravdu chceš skončit?", "Dotaz", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                e.Cancel = true;
            }
        }

        private void Panel_Paint(object sender, PaintEventArgs e)
        {
            Graphics grafika = e.Graphics;
            if (nalezeno)
            {
                Pen pero = new Pen(Color.Black)
                {
                    Width = 1
                };
                NakresliŠachovnici(grafika, pero, out int deltax, out int deltay);
                NakresliDámy(grafika, pero, deltax, deltay);
            }
            else
            {
                grafika.Clear(Color.White);
            }
        }

        private void NakresliDámy(Graphics grafika, Pen pero, int deltax, int deltay)
        {
            pero.Width = 6;
            pero.Color = Color.Red;
            for (int i = 0; i < kolik; i++)
            {
                grafika.DrawEllipse(pero, i * deltax + deltax / 6, řešení[i] * deltay + deltay / 6, 2 * deltax / 3, 2 * deltay / 3);
            }
        }

        private void NakresliŠachovnici(Graphics grafika, Pen pero, out int deltax, out int deltay)
        {
            deltax = panel.Width / kolik;
            deltay = panel.Height / kolik;
            for (int i = 1; i < kolik; i++)
            {
                grafika.DrawLine(pero, 0, i * deltay, panel.Width, i * deltay);
                grafika.DrawLine(pero, i * deltax, 0, i * deltax, panel.Height);
            }
        }

        private void MenuVšechna_Click(object sender, EventArgs e)
        {
            PřipravŘešitele();
            MessageBox.Show($"Úloha {kolik} dam má celkem {řešitel.Řešení.Count()} řešení", "Výsledek");
        }
    }
}
