using System;
using System.Threading;
using System.Text;

namespace vlákna1
{
    class VypisovačŘešení
    {
        private Řešitel řešitel;

        public VypisovačŘešení(int n)
        {
            PočetDam = n;
            řešitel = new Řešitel(n);
        }

        public int PočetDam { get; private set; }

        public void VypišVšechnaŘešení()
        {
            while (řešitel.NajdiDalšíŘešení(out int[] řešení))
            {
                //řešitel.Výpis();
                StringBuilder budovatel = new StringBuilder($"{řešitel.PočetNalezenýchŘešení,2}. řešení úlohy {PočetDam,2} dam: (");
                for (int i = 0; i < řešení.Length; i++)
                {
                    budovatel.Append((i == 0 ? "" : ", ") + řešení[i]);
                }
                budovatel.Append(")");
                Console.WriteLine(budovatel.ToString());
            }
        }
    }
    class Program
    {
        static void Main()
        {
            var (n1, n2) = (4, 5);
            var vypisovač1 = new VypisovačŘešení(n1);
            var vypisovač2 = new VypisovačŘešení(n2);
            Thread vlákno1 = new Thread(vypisovač1.VypišVšechnaŘešení);
            Thread vlákno2 = new Thread(vypisovač2.VypišVšechnaŘešení);
            vlákno1.Start();
            vlákno2.Start();
            Console.WriteLine("Spočteno, vypsáno");
        } 
    }
}
