using System;
using System.Threading;
using System.Text;

namespace vlákna1
{
    class VypisovačŘešení
    {
        private Řešitel řešitel;

        public VypisovačŘešení(int n, string jméno)
        {
            PočetDam = n;
            řešitel = new Řešitel(n);
            this.jméno = jméno;
        }

        public int PočetDam { get; private set; }

        public void VypišVšechnaŘešení()
        {
            try
            {
                while (řešitel.NajdiDalšíŘešení(out int[] řešení))
                {
                    StringBuilder budovatel = new StringBuilder($"{jméno}: {řešitel.PočetNalezenýchŘešení,2}. řešení úlohy {PočetDam,2} dam: (");
                    for (int i = 0; i < řešení.Length; i++)
                    {
                        budovatel.Append((i == 0 ? "" : ", ") + řešení[i]);
                    }
                    budovatel.Append(")");
                    Console.WriteLine(budovatel.ToString());
                    Thread.Sleep(millisecondsTimeout: 10);
                }
            }
            catch(ThreadInterruptedException ex)
            {
                // Úmyslně prázdná obsluha
            }
        }
        private readonly string jméno;
    }
    class Program
    {
        static void Main()
        {
            var (n1, n2) = (8, 8);
            var vypisovač1 = new VypisovačŘešení(n1, "Honza");
            var vypisovač2 = new VypisovačŘešení(n2, "Franta");
            Thread vlákno1 = new Thread(vypisovač1.VypišVšechnaŘešení);
            Thread vlákno2 = new Thread(vypisovač2.VypišVšechnaŘešení);
            Console.WriteLine("Pro předčasné ukončení stiskni Enter");
            Thread.Sleep(timeout: TimeSpan.FromSeconds(1));
            vlákno1.Start();
            vlákno2.Start();
            Console.Read();
            vlákno1.Interrupt();
            vlákno2.Interrupt();
            vlákno1.Join();
            vlákno2.Join();
            Console.WriteLine("Spočteno, vypsáno");
        } 
    }
}
