using System;
using System.Net.Http;
using System.Threading.Tasks;

public class AwaitOperator
{
    private static readonly string adresa = "https://docs.microsoft.com/en-us/";
    public static async Task Main()
    {
        Task<int> stahování = StahniStránkuAsync();
        Console.WriteLine($"{nameof(Main)}: Stahování začalo.");
        DělejSvouPráci();
        int délka = await stahování;
        Console.WriteLine($"{nameof(Main)}: Staženo {délka} bajtů.");
    }

    private static void DělejSvouPráci()
    {
        Console.WriteLine("Dělám co umím...");
    }
    private static async Task<int> StahniStránkuAsync()
    {
        Console.WriteLine($"{nameof(StahniStránkuAsync)}: Brzo začne stahování.");

        var klient = new HttpClient();
        byte[] obsah = await klient.GetByteArrayAsync(adresa);

        Console.WriteLine($"{nameof(StahniStránkuAsync)}: Stahování dokončeno.");
        return obsah.Length;
    }
}