using System;
using System.Threading;

namespace verše
{ 
    class Verš
    {
        public bool JsemKočka { get; set; } = false;
        public string Text { get; set; }
        public Verš(string text, bool jsemKočka) => (Text, JsemKočka) = (text, jsemKočka);
        public void Výpis()
        {
            AutoResetEvent mohuPsát = JsemKočka ? Program.píšeKočka : Program.píšePes;
            AutoResetEvent můžeDruhý = JsemKočka ? Program.píšePes : Program.píšeKočka;
            for(int i = 0; i < 10; i++)
            {
                mohuPsát.WaitOne();
                Console.WriteLine(Text);
                můžeDruhý.Set();
            }
        }
    }
    class Program
    {
        public static readonly AutoResetEvent píšeKočka = new AutoResetEvent(true);
        public static readonly AutoResetEvent píšePes = new AutoResetEvent(false);
        public static void Main()
        {
            Console.WriteLine("Pějme všichni sborem:");
            Verš kočka = new Verš("kočka leze dírou", true);
            Verš pes = new Verš("pes oknem", false);
            Thread pišKočku = new Thread(kočka.Výpis);
            Thread pišPsa = new Thread(pes.Výpis);
            pišKočku.Start();
            pišPsa.Start();
            pišKočku.Join();
            pišPsa.Join();
            Console.WriteLine("Nebude-li pršet, nezmoknem");
        }
    }
}